//var host = "http://localhost:2191/";
//var host = "http://192.168.10.5:400/api/";
//var host = "http://glooniverse.co.za/VirginActive_App_API/";
var host = "http://api.lets2015.co.za/api/";

angular.module('virgin.controllers', [])

.controller('baseController', function ($scope, $ionicSideMenuDelegate, $rootScope) {
    $scope.showMenu = function (showMenu, canDrag) {
        $scope.menuShow = showMenu;
        $ionicSideMenuDelegate.canDragContent(canDrag);
    };

    $scope.toggleRight = function () {
        $ionicSideMenuDelegate.toggleRight();
    };

    $scope.setCameraOrPic = function (val) {
        $rootScope.CameraOrPic = val;
    }
        
})

.controller('splashCtrl', function ($scope, $location, $timeout, $ionicViewService, localDataService, $http, $rootScope) {
    $rootScope.customMotivation = null;
    $scope.user = localDataService.getAll(localDataService.tableNames.profile);
    $ionicViewService.nextViewOptions({
        disableBack: true
    });

    document.addEventListener("resume", onResume, false);
    function onResume() {
        var d = new Date();
        var cd = d.getDay();

        $scope.user = localDataService.getAll(localDataService.tableNames.profile);

        var t = $timeout(function () {
            if ($scope.user.length > 0) {
                var request = $http({
                    method: "GET",
                    url: host + "/content/GetMotivationToday?userid=" + $scope.user[0].id + "&challengeid=" + $scope.user[0].challengeid
                }).success(function (data) {
                    if (data.success) {
                        $location.path('/app/motivationEdit');
                    }
                }).error(function (data) {
                    console.log('Err: ' + JSON.stringify(data));
                });
            }

            $timeout.cancel(t);
        }, 1000);
    }

    //Check Video data
    document.addEventListener("deviceready", initPushwoosh, true);

    function initPushwoosh() {
        var pushNotification = window.plugins.pushNotification;
        document.addEventListener('push-notification', function (event) {
            if (event.notification.video.length > 0) {
                console.log(event.notification.video);

                localDataService.updateCache(localDataService.tableNames.video, [{ videoUrl: event.notification.video }]);
                $location.path('/app/shareVideo');
            }            
        });
        pushNotification.onDeviceReady({ projectid: "1086233789290", pw_appid: "EA093-ADA9F" });
    }

    var d = new Date();
    var cd = d.getDay();

    var t = $timeout(function () {
        if ($scope.user.length > 0) {
            var request = $http({
                method: "GET",
                url: host + "/content/GetMotivationToday?userid=" + $scope.user[0].id + "&challengeid=" + $scope.user[0].challengeid
            }).success(function (data) {
                if (data.success) {
                    $location.path('/app/motivationEdit');
                }
                else {
                    $location.path('/app/gallery');
                }
            }).error(function (data) {
                console.log('Err: ' + JSON.stringify(data));
            });
        }
        else {
            $location.path('/intro');
        }

        $timeout.cancel(t);
    }, 1500);
})

.controller('introCtrl', function ($scope, $location, $ionicViewService, utils) {
    utils.trackPage('Intro page');
    $ionicViewService.nextViewOptions({
        disableBack: true
    });

    $scope.ToTutorials = function () {
        utils.trackEvent('Intro page', 'Show me how button', 'click');
        $location.path('/tutorials');
    }
})

.controller('tutorialsCtrl', function ($scope, $location, localDataService, $rootScope, utils) {
    utils.trackPage('Tutorial page');
    $rootScope.noWipe = null;
    $rootScope.customMotivation = null;
    $scope.user = localDataService.getAll(localDataService.tableNames.profile);

    $scope.ToSignUp = function () {
        utils.trackEvent('Tutorial page', 'Got it. lets go button', 'click');
        if ($scope.user.length > 0) {
            $location.path('/app/gallery');
        }
        else {
            $location.path('/app/signup');
        }
    }
})

.controller('SignUpCtrl', function ($scope, $http, $ionicModal, $location, localDataService, $ionicLoading, $ionicViewService, utils) {
    utils.trackPage('SignUp page');
    $ionicViewService.nextViewOptions({
        disableBack: true
    });

    try {
        var pushNotification = window.plugins.pushNotification;

        document.addEventListener("deviceready", initPushwoosh, true);
        function initPushwoosh() {
            pushNotification.onDeviceReady({ projectid: "1086233789290", pw_appid: "EA093-ADA9F" });
            pushNotification.unregisterDevice(function (token) {
                //alert("unregistered, old token " + token);
                console.log('unregistered');
            },
            function (status) {
                //alert("failed to unregister: " + status);
                console.warn(JSON.stringify(['failed to unregister ', status]));
            });
        }
    }
    catch (e)
    { }
    $scope.showMenu(false, false);
    $scope.AreMember = false;

    $scope.user = {};
    $scope.user.membershipnr = null;
    $scope.user.cell = null;
    $scope.user.contactme = false;

    try {
        $scope.user.uuid = window.device.uuid;
    } catch (e) {
        $scope.user.uuid = '';
    }

    $scope.Member = function (member) {
        $scope.AreMember = member;
    };

    $scope.signUp = function (user) {
        utils.trackEvent('SignUp page', 'Next button', 'click');
        var error = false;
        $scope.errorMessage = "";

        if (user.cell != null) {
            try {
                user.cell = user.cell + '';
            }
            catch (w) { }
        }

        if (user.membershipnr != null) {
            try {
                user.membershipnr = user.membershipnr + '';
            }
            catch (w) { }
        }

        if (user.name == null) {
            $scope.errorMessage = "NAME<br/>";
            error = true;
        }

        if (user.email == null) {
            $scope.errorMessage += "VALID EMAIL<br/>";
            error = true;
        }

        if (user.cell != null) {
            if (user.cell.length > 0) {
                var patt = new RegExp(/^0[6-9](\d{8})/);
                var result = patt.test(user.cell);

                if (!patt.test(user.cell)) {
                    $scope.errorMessage += "VALID CELLPHONE NUMBER<br/>";
                    error = true;
                }
            }
        }

        if (!user.AgreeTerms) {
            $scope.errorMessage += "AGREE TO TERMS AND CONDITIONS<br/>";
            error = true;
        }

        if ($scope.AreMember) {
            if (user.membershipnr == null) {
                $scope.errorMessage += "ENTER MEMBERSHIP NUMBER<br/>";
                error = true;
            }

            if (user.membershipnr != null && (user.membershipnr + '').length != 10) {
                $scope.errorMessage += "VALID NUMBER ON THE BACK OF YOUR MEMBERSHIP CARD<br/>";
                error = true;
            }
        }

        if (error) {
            //Validation modal
            $ionicModal.fromTemplateUrl('templates/ValidationPopup.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.valmodal = modal;
                $scope.valmodal.show();
            });
            return;
        }

        //display loading screen
        $ionicLoading.show({
            template: 'Loading...'
        });

        //register for pushes
        pushNotification.registerDevice(
            function (status) {
                if (window.device.platform == 'Android') {
                    $scope.user.pushid = status;
                } else {
                    $scope.user.pushid = status['deviceToken']
                }

                var request = $http({
                    method: "POST",
                    url: host + "/input/SignUpUser",
                    data: user
                }).success(function (data) {
                    localDataService.updateCache(localDataService.tableNames.profile, [{ id: data.UserID, name: user.name, email: user.email, cell: user.cell, membershipnr: user.membershipnr, interested: user.interested, challengeid: data.challengeid, }]);
                    $ionicLoading.hide();
                    if (!data.exist) {
                        $location.path('/app/challenges');
                    }
                    else {
                        $location.path('/app/gallery');
                    }
                }).error(function (data) {
                    $ionicLoading.hide();
                    console.log('Err: ' + JSON.stringify(data));
                });
            },
            function (status) {
                $ionicLoading.hide();
                console.warn(JSON.stringify(['failed to register ', status]));
            }
        );


    };

    //Terms and conditions modal
    $ionicModal.fromTemplateUrl('templates/terms-conditions.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modal = modal;
    });

    $scope.openModal = function () {
        utils.trackEvent('SignUp page', 'Terms and conditiond button', 'click');
        $scope.modal.show();
    };

    //Back button for validation
    $scope.ValidationBack = function () {
        $scope.valmodal.hide();
    };

    //Back button for terms and conditions
    $scope.Back = function () {
        $scope.modal.hide();
    };
    //Cleanup the modal when we're done with it!
})

.controller('challengesCtrl', function ($scope, $http, $location, localDataService, $stateParams, $rootScope, $ionicLoading, utils, $ionicViewService, $ionicModal) {
    $rootScope.customMotivation = null;
    utils.trackPage('Select a challenge page');
    $ionicViewService.nextViewOptions({
        disableBack: true
    });

    $ionicLoading.show({
        template: 'Loading...'
    });
    $rootScope.noWipe = null;
    if ($stateParams.update != null) {
        $scope.showMenu(true, false);
    }
    else {
        $scope.showMenu(false, false);
    }

    var calList = [{ 'left': 100, 'top': 185, 'class': 'janPosition' },//january
                   { 'left': 100, 'top': 185, 'class': 'febPosition' },//february
                   { 'left': 100, 'top': 185, 'class': 'marPosition' },//march
                   { 'left': 100, 'top': 276, 'class': 'aprPosition' },//april
                   { 'left': 100, 'top': 212, 'class': 'mayPosition' },//may
                   { 'left': 100, 'top': 203, 'class': 'junPosition' },//june
                   { 'left': 100, 'top': 348, 'class': 'julPosition' },//july
                   { 'left': 100, 'top': 228, 'class': 'augPosition' },//august
                   { 'left': 100, 'top': 266, 'class': 'sepPosition' },//september
                   { 'left': 100, 'top': 307, 'class': 'octPosition' },//october
                   { 'left': 156, 'top': 119, 'class': 'novPosition' },//november
                   { 'left': 113, 'top': 170, 'class': 'decPosition' }];//december

    $scope.user = localDataService.getAll(localDataService.tableNames.profile);
    var d = new Date();
    var s = d.getMonth() + 1;

    $scope.monthClass = calList[s - 1].class;
    $scope.dateImgSrc = 'img/shapes/img-' + s + '.png';

    function saveChallengePic(selectedChallenge) {
        var canvas = document.getElementById('cPreview');
        var ctx = canvas.getContext('2d');
        var gradient = ctx.createLinearGradient(0, 640, 640, 0);
        gradient.addColorStop(0, "rgb(115, 44, 89)");
        gradient.addColorStop(1, "rgb(186, 39, 54)");
        ctx.fillStyle = gradient;
        ctx.fillRect(0, 0, 640, 640);
        ctx.restore();
        var img = new Image();
        img.src = $scope.dateImgSrc;
        //console.log($scope.dateImgSrc);

        function wrapText(context, text, x, y, maxWidth, lineHeight) {
            var words = text.split(' ');
            var line = '';

            for (var n = 0; n < words.length; n++) {
                var testLine = line + words[n] + ' ';
                var metrics = context.measureText(testLine);
                var testWidth = metrics.width;
                if (testWidth > maxWidth && n > 0) {
                    context.fillText(line, x, y);
                    line = words[n] + ' ';
                    y += lineHeight;
                }
                else {
                    line = testLine;
                }
            }
            context.fillText(line, x, y);
        }

        img.onload = function () {
            ctx.drawImage(img, 0, 0, 640, 640);
            ctx.font = "bold 39px Arial";
            //ctx.fillStyle = 'white';
            ctx.fillStyle = '#f4f2df';
            wrapText(ctx, selectedChallenge.ChallengeTitle, calList[s - 1].left, calList[s - 1].top, 260, 42);
            ctx.font = "15px Arial";
            if (calList[s - 1].class == 'novPosition') {
                wrapText(ctx, selectedChallenge.Challenge, calList[s - 1].left, calList[s - 1].top + 158, 253, 20);
            }
            else {
                wrapText(ctx, selectedChallenge.Challenge, calList[s - 1].left, calList[s - 1].top + 168, 253, 20);
            }
            ctx.save();
            var fileURL = '';

            /**** PHONE CODE ***********************/

            window.canvas2ImagePlugin.saveImageDataToLibrary(function (msg) {
                fileURL = msg;

                var params = {};
                params.userid = $scope.user[0].id;
                params.challengeid = selectedChallenge.ID;
                params.motivationid = null;

                var options = new FileUploadOptions();
                options.fileKey = "file";
                options.fileName = fileURL;
                options.mimeType = "application/octet-stream";
                options.httpMethod = 'POST';
                options.params = params;

                    var ft = new FileTransfer();

                ft.upload(
                    fileURL,
                    encodeURI(host + "input/UploadFile"),
                    win,
                    fail,
                    options);

            }, function (err) {
            }, document.getElementById('cPreview'));

            var win = function (r) {
                var obj = JSON.parse(r.response);
                $rootScope.challengeImg = obj.imagePath;
            }
            var fail = function (error) {
                console.log('File upload failed - ' + error);
                //console.log(JSON.stringify(error));
            }
        }
    }

    $scope.challengesLoaded = false;
    var request = $http({
        method: "GET",
        url: host + "/content/getchallenges"
    }).success(function (data) {
        $scope.challenges = data;
        $scope.pageIndex = 1;
        $scope.pageTotal = data.length;
        $scope.challengesLoaded = true;
        $ionicLoading.hide();

    }).error(function (data) {
        console.log('Err: ' + data);
        $ionicLoading.hide();
    });

    $scope.slideHasChanged = function (pi) {
        $scope.pageIndex = pi + 1;
    };

    $scope.ToFrequency = function (selectedChallenge) {
        utils.trackEvent('Select a challenge page', 'Accept Challenge button', 'click');
        $ionicLoading.show({
            template: 'Loading...'
        });
        saveChallengePic(selectedChallenge);

        localDataService.updateCache(localDataService.tableNames.profile, [{ challengeid: selectedChallenge.ID }]);
        if ($stateParams.update != null) {
            $ionicLoading.hide();

            //SHOW THANKS, ON OK GO TO GALLERY
            $ionicModal.fromTemplateUrl('templates/challengeChangePopup.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.valmodal = modal;
                $scope.valmodal.show();
            });
        }
        else {
            $ionicLoading.hide();
            $location.path('/app/frequency');
        }
    };

    $scope.ThankyouOK = function () {
        $scope.valmodal.hide();
        $location.path('/app/gallery');
    }
})

.controller('frequencyCtrl', function ($scope, $http, $location, localDataService, $stateParams, $rootScope, $ionicLoading, utils, $ionicViewService, $ionicModal) {
    $rootScope.customMotivation = null;
    utils.trackPage('Select a frequency page');

    $ionicViewService.nextViewOptions({
        disableBack: true
    });

    $ionicLoading.show({
        template: 'Loading...'
    });

    $rootScope.noWipe = null;

    if ($stateParams.updateBool == null) {
        $scope.showMenu(false, false);
    }
    else {
        $scope.showMenu(true, true);
    }

    $scope.user = localDataService.getAll(localDataService.tableNames.profile);

    $scope.frequencyLoaded = false;
    $scope.frequencyTimesLoaded = false;

    //Select time function
    $scope.checkTimeSelect = function (freq, freqID, freqTimeID) {
        if (localDataService.getByQuery(localDataService.tableNames.frequency, { frequencyId: freqID, frequencyTimeId: freqTimeID }).length > 0) {
            freq.selectedTime = freqTimeID;
        }

        return localDataService.getByQuery(localDataService.tableNames.frequency, { frequencyId: freqID, frequencyTimeId: freqTimeID }).length > 0;
    }

    //Load day frequencies
    var request = $http({
        method: "GET",
        url: host + "/content/GetFrequency"
    }).success(function (data) {
        //console.log(data);
        $scope.frequencies = data;
        $scope.frequencies.forEach(function (item) {
            //Check if selected
            var check = localDataService.getByQuery(localDataService.tableNames.frequency, { frequencyId: item.ID });
            if (check.length > 0) {
                item.isSelected = true;
                item.Frequency = item.Frequency;
            } else {
                item.isSelected = false;
            }
        });
        $scope.frequencyLoaded = true;
    }).error(function (data) {
        console.log('Err: ' + data);
    });

    //Load time frequencies
    var request = $http({
        method: "GET",
        url: host + "/content/GetFrequencyTimes"
    }).success(function (data) {
        //console.log(data);
        $scope.frequencyTimes = data;
        $scope.frequencyTimesLoaded = true;
        $ionicLoading.hide();
    }).error(function (data) {
        $ionicLoading.hide();
        console.log('Err: ' + data);
    });

    $scope.ToFrequencyComplete = function () {
        utils.trackEvent('Select a frequency page', 'Next button', 'click');
        $ionicLoading.show({
            template: 'Loading...'
        });

        var selectedItems = [];
        for (var i = 0; i < $scope.frequencies.length; i++) {
            if ($scope.frequencies[i].selectedTime != null) {
                selectedItems.push({
                    frequencyid: $scope.frequencies[i].ID,
                    frequencttimeid: parseInt($scope.frequencies[i].selectedTime),
                    userid: $scope.user[0].id
                });
            }
        }

        if (selectedItems.length > 0) {
            var request = $http({
                method: "POST",
                url: host + "/input/SetUserFrequency",
                data: selectedItems
            }).success(function (data) {
                //Save to local db
                localDataService.truncateTable(localDataService.tableNames.frequency);

                for (var i = 0; i < selectedItems.length; i++) {
                    localDataService.updateItem(localDataService.tableNames.frequency, '', { frequencyId: selectedItems[i].frequencyid, frequencyTimeId: selectedItems[i].frequencttimeid });
                }

                if ($stateParams.updateBool == null) {
                    $ionicLoading.hide();
                    $location.path('/app/challengeShare');
                }
                else {
                    $ionicLoading.hide();
                    $ionicModal.fromTemplateUrl('templates/frequencyChangePopup.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        $scope.modal = modal;
                        $scope.modal.show();
                    });
                }

            }).error(function (data) {
                $ionicLoading.hide();
                console.log('Err: ' + JSON.stringify(data));
            });
        }
        else {
            // ERROR MESSAGE MODEL
        }
        $ionicLoading.hide();
    };
    $scope.removeTime = function (frequency) {
        var select = document.getElementById('ddl' + frequency.ID);
        select.value = '';

        if (frequency.selectedTime == null && frequency.isSelected == null)
            return;

        frequency.selectedTime = null;
        frequency.isSelected = null;
    }

    $scope.ThankyouOK = function () {
        $scope.modal.hide();
        $location.path('/app/gallery');
    }
})

.controller('challengeShareCtrl', function ($scope, $http, $location, localDataService, $ionicModal, $rootScope, utils, $ionicViewService) {
    utils.trackPage('Share your challenge page');

    $ionicViewService.nextViewOptions({
        disableBack: true
    });

    $scope.facebook_ICO = 'img/ico/ico-fb.png';
    $scope.twitter_ICO = 'img/ico/ico-twitter.png';
    $scope.Instagram_ICO = 'img/ico/ico-instagram.png';

    $scope.showMenu(false, false);
    $scope.imageUrl = host + 'assets/userimages/' + $rootScope.challengeImg;

    $ionicModal.fromTemplateUrl('templates/challengeShareOverlay.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function () {
        utils.trackPage('Share popup on challenge page');
        $scope.modal.show();
    };
    $scope.Back = function () {
        $scope.modal.hide();
    };

    $scope.shareFacebook = function () {        
        $scope.facebook_ICO = 'img/ico/ico-fb_o.png';

        utils.trackEvent('Share popup on challenge page', 'Facebook button', 'click');

        window.plugins.socialsharing.shareViaFacebook("I'm making every day count. Find your #lets2015 challenge here: www.lets2015.co.za #Lets2015 #Challengeaccepted", $scope.imageUrl.replace('/userimages/', '/userimages/raw/').replace('.jpg','.png'), null/*url*/);
    }

    $scope.shareTwitter = function () {        
        $scope.twitter_ICO = 'img/ico/ico-twitter_o.png';

        utils.trackEvent('Share popup on challenge page', 'Twitter button', 'click');

        window.plugins.socialsharing.shareViaTwitter("I'm making every day count. Find your #lets2015 challenge here: www.lets2015.co.za #Lets2015 #Challengeaccepted", $scope.imageUrl.replace('/userimages/', '/userimages/raw/').replace('.jpg', '.png'), null/*url*/);
    }

    $scope.shareInstagram = function () {        
        $scope.Instagram_ICO = 'img/ico/ico-instagram_o.png';

        utils.trackEvent('Share popup on challenge page', 'Instagram button', 'click');

        Instagram.isInstalled(function (err, installed) {
            if (installed) {
                //console.log("Instagram version: ", installed); // installed app version on Android
            } else {
                console.log("Instagram is not installed");
            }
        });

        var canvas = document.getElementById('saveCanvas'), ctx = canvas.getContext('2d');
        var saveImg = new Image();
        saveImg.src = $scope.imageUrl.replace('/userimages/', '/userimages/raw/').replace('.jpg', '.png');

        saveImg.onload = function () {
            ctx.drawImage(saveImg, 0, 0, canvas.width, canvas.width);
            //Share
            try {
                var data = canvas.toDataURL();
                Instagram.share(data, "#LETS2015", function (err) {
                    if (err) {
                        console.log("not shared");
                    } else {
                        //console.log("shared");
                    }
                });
            }
            catch (e) {
                console.log("big error: " + JSON.stringify(e));
            }
        }
    };

    $scope.ToShare = function () {
        $scope.modal.show();
    }

    $scope.ToFrequencyComplete = function () {
        $location.path('/app/frequencyComplete');
    };
})

.controller('frequencyCompleteCtrl', function ($scope, $http, $stateParams, localDataService, $rootScope, utils, $ionicViewService) {
    utils.trackPage('Signup complete page');

    $ionicViewService.nextViewOptions({
        disableBack: true
    });

    $scope.showMenu(true, true);

    $scope.imageUrl = host + '/assets/userimages/' + $rootScope.challengeImg;

    $scope.Notification = 'SOON';

    $scope.user = localDataService.getAll(localDataService.tableNames.profile);

    //Get next motivationDate
    var request = $http({
        method: "GET",
        url: host + "/content/GetNextMotivationDate?userid=" + $scope.user[0].id
    }).success(function (data) {
        $scope.Notification = 'ON ' + data.day + ' AT ' + data.time;
    }).error(function (data) {
        console.log('Err: ' + data);
    });
})

.controller('termsPageCtrl', function ($scope, $location, $rootScope, utils) {
    //utils.trackPage('Tracking V3 - terms page');
    $rootScope.customMotivation = null;
    utils.trackPage('Terms and conditions page');
    $rootScope.noWipe = null;
    $scope.showMenu(false, true);

    $scope.Back = function () {
        utils.trackEvent('Terms and conditions page', 'Back button', 'click');
        window.history.back();
    }
})

.controller('galleryCtrl', function ($scope, $location, localDataService, $http, $rootScope, $ionicLoading, utils) {
    utils.trackPage('Gallery page');
    $ionicLoading.show({
        template: 'Loading...'
    });
    $rootScope.noWipe = null;
    $rootScope.customMotivation = null;
    $scope.showMenu(true, true);
    $scope.host = host;
    $scope.user = localDataService.getAll(localDataService.tableNames.profile);

    var d = new Date();
    var s = d.getMonth() + 1;

    var calList = [{ 'class': 'janPosition' },//january
                   { 'class': 'febPosition' },//february
                   { 'class': 'marPosition' },//march
                   { 'class': 'aprPosition' },//april
                   { 'class': 'mayPosition' },//may
                   { 'class': 'junPosition' },//june
                   { 'class': 'julPosition' },//july
                   { 'class': 'augPosition' },//august
                   { 'class': 'sepPosition' },//september
                   { 'class': 'octPosition' },//october
                   { 'class': 'novPosition' },//november
                   { 'class': 'decPosition' }];//december

    $scope.monthClass = calList[s - 1].class;

    $scope.monthImg = 'img/shapes/img-' + s + '.png';
    //Load gallery
    var request = $http({
        method: "GET",
        url: host + "/content/GetGallery?userid=" + $scope.user[0].id
    }).success(function (data) {
        $scope.galleryItems = data;
        $ionicLoading.hide();
    }).error(function (data) {
        $ionicLoading.hide();
        //console.log(data);
    });

    $scope.DetailView = function (challId, motiId) {
        $location.path('/app/motivationDetail/' + challId + '/' + motiId);
    }
})

.controller('motivationDetailCtrl', function ($scope, $location, localDataService, $stateParams, $http, $ionicModal, utils) {
    utils.trackPage('Motivation detail page');
    $scope.showMenu(true, false);

    $scope.facebook_ICO = 'img/ico/ico-fb.png';
    $scope.twitter_ICO = 'img/ico/ico-twitter.png';
    $scope.Instagram_ICO = 'img/ico/ico-instagram.png';
    

    var calList = [{ 'class': 'janPosition' },//january
               { 'class': 'febPosition' },//february
               { 'class': 'marPosition' },//march
               { 'class': 'aprPosition' },//april
               { 'class': 'mayPosition' },//may
               { 'class': 'junPosition' },//june
               { 'class': 'julPosition' },//july
               { 'class': 'augPosition' },//august
               { 'class': 'sepPosition' },//september
               { 'class': 'octPosition' },//october
               { 'class': 'novPosition' },//november
               { 'class': 'decPosition' }];//december

    $scope.host = host;
    $scope.user = localDataService.getAll(localDataService.tableNames.profile);

    var d = new Date();
    var s = d.getMonth() + 1;

    $scope.monthClass = calList[s - 1].class;
    $scope.monthImg = 'img/shapes/img-' + s + '.png';

    //If challenge you cant edit
    if ($stateParams.motivationID == null || $stateParams.motivationID == 'null' || $stateParams.motivationID == '') {
        $scope.canEdit = false;
    }
    else { $scope.canEdit = true; }

    //Load gallery
    var request = $http({
        method: "GET",
        url: host + "/content/GetGallery?userid=" + $scope.user[0].id
    }).success(function (data) {
        $scope.galleryItems = data;
        $scope.pageIndex = 0;

        if ($scope.canEdit) {
            for (var i = 0; i < $scope.galleryItems.length; i++) {
                if ($scope.galleryItems[i].ChallengeID == $stateParams.challengeID && $scope.galleryItems[i].MotivationID == $stateParams.motivationID) {
                    $scope.pageIndex = i;
                }
            }
        }
        else {
            for (var i = 0; i < $scope.galleryItems.length; i++) {
                if ($scope.galleryItems[i].ChallengeID == $stateParams.challengeID) {
                    $scope.pageIndex = i;
                }
            }
        }
    }).error(function (data) {
        //console.log(data);
    });

    $scope.slideHasChanged = function (index) {
        $scope.pageIndex = index;
        if ($scope.galleryItems[index].MotivationID == null || $scope.galleryItems[index].MotivationID == 'null' || $scope.galleryItems[index].MotivationID == '') {
            $scope.canEdit = false;
        }
        else { $scope.canEdit = true; }
    }

    $scope.ToEdit = function () {
        $ionicModal.fromTemplateUrl('templates/resetMessagePopup.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.valmodal = modal;
            $scope.valmodal.show();
        });
    };

    $scope.resetOK = function () {
        $scope.valmodal.hide();
        $location.path('/app/motivationEdit/' + $scope.galleryItems[$scope.pageIndex].ChallengeID + '/' + $scope.galleryItems[$scope.pageIndex].MotivationID);
    }

    $scope.resetCancel = function () {
        $scope.valmodal.hide();
    }

    $scope.ShareThis = function (img) {
        utils.trackPage('Share popup on motivation detail page');
        $scope.imageUrl = host + 'assets/userimages/' + $scope.galleryItems[$scope.pageIndex].conImage;
        $ionicModal.fromTemplateUrl('templates/challengeShareOverlay.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {

            $scope.modal = modal;
            $scope.modal.show();
        });
    };

    $scope.Back = function () {
        $scope.modal.hide();
    };

    $scope.shareFacebook = function () {
        $scope.facebook_ICO = 'img/ico/ico-fb_o.png';

        utils.trackEvent('Share popup on motivation detail page', 'Facebook button', 'click');
	    
        window.plugins.socialsharing.shareViaFacebook('How are you making every day count? Find your #Lets2015 challenge here: www.lets2015.co.za #Lets2015 #Challengeaccepted', $scope.imageUrl.replace('/userimages/', '/userimages/raw/').replace('//asset','/asset').replace('.jpg','.png'), null/*url*/, function(){
            $scope.Back();
        });
    }

    $scope.shareTwitter = function () {
        $scope.twitter_ICO = 'img/ico/ico-twitter_o.png';        

        utils.trackEvent('Share popup on motivation detail page', 'Twitter button', 'click');

        window.plugins.socialsharing.shareViaTwitter('How are you making every day count? Find your #Lets2015 challenge here: www.lets2015.co.za #Challengeaccepted', $scope.imageUrl.replace('/userimages/', '/userimages/raw/').replace('//asset','/asset').replace('.jpg','.png'), null/*url*/, function(){
            $scope.Back();
        });
    }

    $scope.shareInstagram = function () {
        $scope.Instagram_ICO = 'img/ico/ico-instagram_o.png';

        utils.trackEvent('Share popup on motivation detail page', 'Instagram button', 'click');

        Instagram.isInstalled(function (err, installed) {
            if (installed) {
                //console.log("Instagram version: ", installed); // installed app version on Android
            } else {
                console.log("Instagram is not installed");
            }
        });

        var canvas = document.getElementById('saveCanvas'), ctx = canvas.getContext('2d');
        var saveImg = new Image();
        saveImg.src = $scope.imageUrl.replace('/userimages/', '/userimages/raw/').replace('.jpg', '.png');

        saveImg.onload = function () {
            ctx.drawImage(saveImg, 0, 0, canvas.width, canvas.width);
            //Share
            try {
                var data = canvas.toDataURL();
                Instagram.share(data, "#LETS2015", function (err) {
                    if (err) {
                        console.log("not shared");
                    } else {
                        //console.log("shared");
                    }
                });
            }
            catch (e) {
                console.log("big error: " + JSON.stringify(e));
            }
        }
    };
})

.controller('motivationEditCtrl', function ($scope, $location, localDataService, $stateParams, $http, $rootScope, $ionicModal, $ionicLoading, utils) {
    utils.trackPage('Edit motication page');
    $scope.showMenu(true, false);
    $scope.editClass = 'editTextPosition';
    $scope.user = localDataService.getAll(localDataService.tableNames.profile);
    $rootScope.saveDone = false;

    var calList = [{ 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 3.5, 'class': 'editTextPosition' },//january
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 3.5, 'class': 'editTextPosition' },//february
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 3.5, 'class': 'editTextPosition' },//march
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 2.35, 'class': 'editTextPositionLeft' },//april
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 3.1, 'class': 'editTextPositionRight' },//may
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 3., 'class': 'editTextPosition' },//june
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 1.86, 'class': 'editTextPositionLeftDown' },//july
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 2.9, 'class': 'editTextPositionRight' },//august
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 2.4, 'class': 'editTextPosition' },//september
                  { 'left': window.innerWidth / 6.4, 'top': window.innerWidth / 2.1, 'class': 'editTextPosition' },//october
                  { 'left': window.innerWidth / 4.2, 'top': window.innerWidth / 5.5, 'class': 'editTextPosition' },//november
                  { 'left': window.innerWidth / 6.1, 'top': window.innerWidth / 3.9, 'class': 'editTextPosition' }];//december

    var canvas = document.getElementById('cPreview'), ctx = canvas.getContext('2d');
    var saveCanvas = document.getElementById('saveCanvas'), saveCtx = saveCanvas.getContext('2d');
    window.addEventListener('resize', resizeCanvas, false);

    function resizeCanvas() {
        canvas.width = window.innerWidth;
        canvas.height = window.innerWidth;
        GetOnlineData();
    }

    function GetOnlineData() {
        //From splash
        if ($stateParams.challengeID == null && $stateParams.motivationID == null) {
            var request = $http({
                method: "GET",
                url: host + "/content/GetMotivationToday?userid=" + $scope.user[0].id + "&challengeid=" + $scope.user[0].challengeid
            }).success(function (data) {
                if (data.success) {
                    //Bind motivation to page
                    $scope.motivation = data.motivation;
                    $scope.motivationid = data.id;
                    drawStuff();
                }
                else {
                    if (!$rootScope.saveDone) {
                        $location.path('/app/gallery');
                    }
                }
            }).error(function (data) {
                console.log('Err: ' + JSON.stringify(data));
            });
        }
            //From gallery
        else {
            if ($rootScope.noWipe == null) {
                $scope.setCameraOrPic(null);
            }

            var request = $http({
                method: "GET",
                url: host + "/content/GetMotivationDetails?userid=" + $scope.user[0].id + "&challengeid=" + $stateParams.challengeID + "&motivationid=" + $stateParams.motivationID
            }).success(function (data) {
                //Bind motivation to page
                if ($rootScope.customMotivation != null && $rootScope.customMotivation.length > 0) {
                    $scope.motivation = $rootScope.customMotivation
                }
                else {
                    $scope.motivation = data.motivation;
                }
                $scope.motivationid = data.id;
                drawStuff();

            }).error(function (data) {
                console.log('Err: ' + JSON.stringify(data));
            });
        }
    }

    function wrapText(context, text, x, y, maxWidth, lineHeight) {
        var words = text.split(' ');
        var line = '';

        for (var n = 0; n < words.length; n++) {
            var testLine = line + words[n] + ' ';
            var metrics = context.measureText(testLine);
            var testWidth = metrics.width;
            if (testWidth > maxWidth && n > 0) {
                context.fillText(line, x, y);
                line = words[n] + ' ';
                y += lineHeight;
            }
            else {
                line = testLine;
            }
        }
        context.fillText(line, x, y);
    }
    function drawStuff() {
        var d = new Date();
        var s = d.getMonth() + 1;

        $scope.editClass = calList[s - 1].class;
        $scope.dateImgSrc = 'img/shapes/img-' + s + '.png';
        var offsetX = 0;
        var offsetY = 0;
        var imgX = 0;
        var imgY = 0;
        var isDragging = false;

        function doTouchStart(e) {
            e.preventDefault();
            isDragging = true;
            offsetX = parseInt(e.touches[0].pageX) - imgX;
            offsetY = parseInt(e.touches[0].pageY) - imgY;
        }

        function doTouchEnd(e) {
            isDragging = false;
            DrawMotivation();
        }

        function doTouchMove(e) {
            imgX = parseInt(e.touches[0].pageX - offsetX);
            imgY = parseInt(e.touches[0].pageY - offsetY);

            if (isDragging) {
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                ctx.drawImage(bgPic, imgX, imgY, bgPic.width, bgPic.height);
            }
        }

        if ($rootScope.CameraOrPic == null) {
            var imgPat = new Image();
            imgPat.src = 'img/ico/bg-repeat.jpg';

            imgPat.onload = function () {
                var ptrn = ctx.createPattern(imgPat, 'repeat'); // Create a pattern with this image, and set it to "repeat".
                ctx.fillStyle = ptrn;
                ctx.fillRect(0, 0, canvas.width, canvas.height);
                ctx.restore();
                DrawMotivation();
            }
        }
        else {
            var bgPic = new Image();

            bgPic.src = $rootScope.CameraOrPic.replace('file://', '');

            bgPic.onload = function () {
                if (bgPic.src.indexOf('gal') > -1) {
                    ctx.drawImage(bgPic, 0, 0, canvas.width, canvas.width);
                    DrawMotivation();
                }
                else {
                    canvas.addEventListener('touchstart', doTouchStart, false);
                    canvas.addEventListener('touchend', doTouchEnd, false);
                    canvas.addEventListener('touchmove', doTouchMove, false);
                    ctx.drawImage(bgPic, 0, 0, bgPic.width, bgPic.height);
                    ctx.save();
                    DrawMotivation();
                }
            }
        }

        function DrawMotivation() {
            var img = new Image();
            img.src = $scope.dateImgSrc;

            img.onload = function () {
                ctx.drawImage(img, 0, 0, window.innerWidth, window.innerWidth);
                ctx.font = "bold 17px Arial";
                //ctx.fillStyle = 'white';
                ctx.fillStyle = '#f4f2df';
                if ($rootScope.customMotivation != null) {
                    $scope.motivation = $rootScope.customMotivation;
                }
                wrapText(ctx, $scope.motivation, calList[s - 1].left, calList[s - 1].top, window.innerWidth / 2, 18);
                ctx.font = "15px Arial";
                wrapText(ctx, "#LETS2015", window.innerWidth / 1.38, window.innerWidth / 1.02, 40, 40);
                //ctx.save();
            }
        }
    }
    $scope.ToImageSelect = function () {
        if ($stateParams.challengeID == null && $stateParams.motivationID == null) {
            $location.path('/app/imageSelect/' + $scope.user[0].challengeid + '/' + $scope.motivationid);
        }
        else {
            $location.path('/app/imageSelect/' + $stateParams.challengeID + '/' + $stateParams.motivationID);
        }
    }

    $ionicModal.fromTemplateUrl('templates/editText.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal1) {

        $scope.modal = modal1;
    });

    $ionicModal.fromTemplateUrl('templates/EditThankYouPopup.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal2) {

        $scope.msgBoxThankyou = modal2;
    });

    $ionicModal.fromTemplateUrl('templates/EditErrorPopup.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal3) {

        $scope.msgBoxError = modal3;
    });

    $scope.$on('modal.hidden', function () {
        if (!$rootScope.saveDone) {
            setTimeout(drawStuff, 500);
        }
    });

    $scope.EditText = function () {
        utils.trackEvent('Edit motication page', 'Edit text button', 'click');
        $scope.modal.show();
    };

    $scope.Cancel = function () {
        $scope.modal.hide();
    };

    $scope.OK = function (text) {
        $scope.motivation = "LET'S " + text.toUpperCase();
        $rootScope.customMotivation = "LET'S " + text.toUpperCase();
        $scope.modal.hide();
    };
    $scope.ErrorClose = function () {
        $scope.msgBoxError.hide();
    }

    $scope.SaveMotivation = function () {
        utils.trackEvent('Edit motication page', 'Save button', 'click');
        $ionicLoading.show({
            template: 'Saving...'
        });
        saveCtx.drawImage(canvas, 0, 0, 640, 640);
        window.canvas2ImagePlugin.saveImageDataToLibrary(function (msg) {
            var fileURL = msg;
            var params = {};
            params.userid = $scope.user[0].id;
            if ($stateParams.challengeID == null) {
                params.challengeid = $scope.user[0].challengeid;
            }
            else
            {
                params.challengeid = $stateParams.challengeID;
            }
            params.motivationid = $scope.motivationid;
            var options = new FileUploadOptions();
            options.fileKey = "file";
            options.fileName = fileURL;
            options.mimeType = "application/octet-stream";

            options.params = params;

            //console.log(options);

            var win = function (re) {
                $rootScope.customMotivation = null;
                $rootScope.saveDone = true;
                $ionicLoading.hide();
                $scope.msgBoxThankyou.show();
            }

            var fail = function (e) {
                $ionicLoading.hide();
                console.log('fileupload err: ' + JSON.stringify(e));
                $scope.msgBoxError.show();
            }

            var ft = new FileTransfer();

            ft.upload(
                fileURL,
                encodeURI(host + "/input/SaveMotivationFile"),
                win,
                fail,
                options);

        }, function (err) {
        }, document.getElementById('saveCanvas'));
    }
    $scope.motivation = '';
    resizeCanvas();
    $scope.ThankyouOK = function () {
        $scope.msgBoxThankyou.hide();
        $location.path('/app/gallery');
    }
})

.controller('imageSelectCtrl', function ($scope, $location, $stateParams, $rootScope, utils) {
    utils.trackPage('Select image page');
    $scope.showMenu(true, true);

    $scope.selectImage = function (img) {
        utils.trackEvent('Select image page', 'Select VirginActive image button', 'click');
        $scope.setCameraOrPic(img);

        if ($stateParams.challengeID == null && $stateParams.motivationID == null) {
            $location.path('/app/motivationEdit');
        }
        else {
            $rootScope.noWipe = true;
            $location.path('/app/motivationEdit/' + $stateParams.challengeID + '/' + $stateParams.motivationID);
        }
    }

    $scope.takepicture = function () {
        utils.trackEvent('Select image page', 'Take image with camera button', 'click');
        navigator.camera.getPicture(function (imageURI) {

            //PASS TO EDIT PAGE
            $scope.setCameraOrPic(imageURI);
            $rootScope.noWipe = true;
            $location.path('/app/motivationEdit/' + $stateParams.challengeID + '/' + $stateParams.motivationID);
            $scope.$apply();

        }, function (err) {
            console.log('camera error');
        }, {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 720,
            targetHeight: 720,
            saveToPhotoAlbum: true,
            correctOrientation: true,
            cameraDirection: 0
        });
    }
})

.controller('shareVideoCtrl', function ($scope, $location, $ionicViewService, utils, $ionicModal) {
    utils.trackPage('Share video page');
    $scope.showMenu(true, true);

    $scope.vid = localDataService.getAll(localDataService.tableNames.video);

    document.getElementById('video_container').innerHTML =
                    '<iframe style="margin:0;padding:0;border:none;" width="' + window.innerWidth + '" height="' + window.innerWidth + '"'
                    + ' src="'+$scope.vid[0].videoUrl+'" frameborder="0">'
                    + '</iframe>';

    $scope.Back = function () {
        $scope.modal.hide();
    };

    $scope.ShareThisVid = function () {
        utils.trackPage('Share popup on video page');        
        $scope.imageUrl = $scope.vid[0].videoUrl;
        $ionicModal.fromTemplateUrl('templates/videoShareOverlay.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal = modal;
            $scope.modal.show();
        });
    };

    $scope.shareFacebook = function () {
        utils.trackEvent('Share popup on video page', 'Facebook button', 'click');
        window.plugins.socialsharing.shareViaFacebook('I am making every day count! #Lets2015 ', $scope.imageUrl, null);
    }

    $scope.shareTwitter = function () {
        utils.trackEvent('Share popup on video page', 'Twitter button', 'click');
        window.plugins.socialsharing.shareViaTwitter('I am making every day count! #Lets2015 ', null, $scope.imageUrl);
    }
})