﻿'use strict';

angular.module('virgin.services.utils', [])
    .factory('utils', function () {
        var analytics = navigator.analytics;
        var code = "UA-60345979-1";        

        function Init()
        {
            analytics = navigator.analytics;
        }

        function trackPage(pageName) {
            //eg. utils.trackPage('Intro page');

            if (analytics == null || analytics == undefined) {
                errorCallback();
                return;
            }

            // set the tracking id
            analytics.setTrackingId(code);
            //analytics.sendAppView(pageName, successCallback, errorCallback);

            var Fields = analytics.Fields,
            HitTypes = analytics.HitTypes,
            LogLevel = analytics.LogLevel,
            params = {};

            params[Fields.HIT_TYPE] = HitTypes.APP_VIEW;
            params[Fields.SCREEN_NAME] = pageName;

            analytics.setLogLevel(LogLevel.INFO);
            analytics.send(params, successCallback, errorCallback);
        };

        function successCallback() {
            console.log('GA Tracked');
        }

        function errorCallback(e) {
            console.log('GA Failed');
        }

        function successEventCallback() {
            console.log('GA Event Tracked');
        }

        function errorEventCallback(e) {
            console.log('GA Event Failed');
        }

        function trackEvent(eventPage, eventName, eventType) {
            //eg. utils.trackEvent('Intro page', 'Show me how button', 'click');

            if (analytics == null || analytics == undefined) {
                errorCallback();
                return;
            }

            // set the tracking id
            analytics.setTrackingId(code);

            var Fields = analytics.Fields,
            HitTypes = analytics.HitTypes,
            LogLevel = analytics.LogLevel,
            params = {};

            params[Fields.HIT_TYPE] = HitTypes.EVENT;
            params[Fields.EVENT_CATEGORY] = eventPage;
            params[Fields.EVENT_ACTION] = eventName;
            params[Fields.EVENT_LABEL] = eventType;

            analytics.setLogLevel(LogLevel.INFO);
            analytics.send(params, successEventCallback, errorEventCallback);
        };

        return {
            Init: Init,
            trackPage: trackPage,
            trackEvent: trackEvent
        }
    });